variables:
  IMAGE_NAME: temur98/blog-app
  IMAGE_TAG: latest
  PWD: 

stages:
  - build
  - migrate
  - deploy

build-image:
  stage: build
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - docker login -u $REGISTRY_USER -p $REGISTRY_PASS
  script:
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
    - docker push $IMAGE_NAME:$IMAGE_TAG
  only:
    - main

migrate:
  image: alpine
  stage: migrate
  before_script:
    - apk add wget && wget https://github.com/golang-migrate/migrate/releases/download/v4.14.1/migrate.linux-amd64.tar.gz
    - tar -xvf migrate.linux-amd64.tar.gz && mv migrate.linux-amd64 migrate && chmod +x migrate
  script:
    - ./migrate -path migrations -database "$DATABASEURL" up
  only:
    - main
  
deploy:
  stage: deploy
  before_script:
    - chmod 400 $SSH_KEY
  script:
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY ubuntu@18.198.189.166 "
        docker login -u $REGISTRY_USER -p $REGISTRY_PASS &&
        docker pull $IMAGE_NAME:$IMAGE_TAG &&
        cd blog_app_devops && 
        make up " 
  only:
    - main
